import java.awt.Dimension;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JCheckBox;
import javax.swing.JFormattedTextField;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;


public class Question {
	private String description;
	private int type;

	List<String> repTab; //tableau o on stocke toutes les rponses
	
	public Question(String description, int type, List<String> rep){
		this.description = description;
		this.type = type;
		this.repTab = rep;
	}

	public Question(){
		this.description= JOptionPane.showInputDialog(null, "Posez votre question", "Question", JOptionPane.QUESTION_MESSAGE);
		this.type = 4; //rep txt par dfaut
		this.repTab = new ArrayList<String>(); //tableau vide, sans rponses
	}
	


	
	//-------------------------------------------

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public List<String> getRepTab() { //get tableau contenant toutes les rponses
		return this.repTab;
	}

	public int getType() {
		return type;
	}

	public void setType(int type) {
		this.type = type;
	}


	
	//--------------- CHOISIR TYPE DE REPONSE DE LA QUESTION ------------------
	
		// Demander quel type de rponses (1. ouverte (texte), 2. checkbox, 3. radio (1choix), 4. numrique)
		
		public int typeReponse(String[] choices){
			int choix;

			 do{
			    String s = (String) JOptionPane.showInputDialog(
					null,
					"Choisissez un type de rponse :",
					"Type de rponse",
					JOptionPane.PLAIN_MESSAGE,
					null,
					choices,
					choices[0]);
					
			    
				if (s == "Question  rponses multiples"){
					choix = 1;
					this.setType(1);
					
					
				} else if (s == "Question  rponse unique") {
					choix = 2;
					this.setType(2);
				
				} else if (s == "Question  rponse numrique"){
					choix = 3;
					this.setType(3);
					
				} else if (s == "Question  rponse texte"){
					choix = 4;
					this.setType(4); //Rponse texte par dfaut
				} 
				else {
					choix = 0; // on ne fait rien si on appuie sur autre chose
					this.setType(0);
				};
				
				System.out.println("Vous avez choisi la rponse"+ choix);
				return choix;
		    }
		    while ((choix != 1) || (choix != 2) || (choix != 3) || (choix != 4) || (choix != 0));
			
		}
		
	
	//---------------- AFFICHAGE REPONSES SELON LE TYPE DE LA QUESTION -------------------
	
	public void afficherReponse(Fenetre fenetre, JPanel pan){
		JRadioButton[] tabRadioButton = new JRadioButton[this.getRepTab().size()]; //Tableau de RadioButton
		JCheckBox[] tabCheckBox = new JCheckBox[this.getRepTab().size()]; //Tableau de CheckBox
			 
				
		switch(this.getType())
		{
			case 1 : //JCheckBox - QCM
				
				for (int i=0; i< this.getRepTab().size(); i++){ //on parcoure le tableau de rponses
					tabCheckBox[i] = new JCheckBox(this.getRepTab().get(i)); 
					
					pan.add(tabCheckBox[i]);
					
					fenetre.setContentPane(pan);
					fenetre.setVisible(true);
				}
				break;
				
			case 2 : //RadioButton - Question  choix unique
				
				for (int i=0; i< this.getRepTab().size(); i++){ //on parcoure le tableau de rponses
					tabRadioButton[i] = new JRadioButton(this.getRepTab().get(i)); 
					
					pan.add(tabRadioButton[i]);
					
					fenetre.setContentPane(pan);
					fenetre.setVisible(true);
				}
				break;
		}
		
		
	}
	
	
	public JFormattedTextField reponseNumerique(){
			
		JFormattedTextField numerique = new JFormattedTextField(NumberFormat.getIntegerInstance());
		numerique.setPreferredSize(new Dimension(100,25));
			
		return numerique; //il faut rcuprer l'input de l'utilisateur (= sa rponse)
		
	}
	
	
	public JTextField texte(){
		
		JTextField txt = new JTextField(30); 
		
		return txt;  //il faut rcuprer l'input de l'utilisateur (= sa rponse)

	}
	
	
	
}
